#include <iostream>
#include "QuadTree.h"



int main (){
    auto boundary = AABB( XY(4,8), 4);
    auto tree = QuadTree(boundary);

    //tree.print();
    
    std::cout << "inserting random points into tree !!" << std::endl;

    if(!tree.insert({2,7}))
        std::cout << "insert failed!" << std::endl;
    
    if(!tree.insert({3,11}))
        std::cout << "insert failed!" << std::endl;

    if(!tree.insert({2,6}))
        std::cout << "insert failed!" << std::endl;

    if(!tree.insert({1,4}))
        std::cout << "insert failed!" << std::endl;

    // subdivision will now be necessary

    if(!tree.insert({6,5}))
        std::cout << "insert failed!" << std::endl;

    if(!tree.insert({7,10}))
        std::cout << "insert failed!" << std::endl;

    std::cout << "print tree " << std::endl;
    tree.print();




    std::cout << "Get points within bounds " << std::endl;
    auto pointInRange = tree.queryRange(AABB {XY{ 4, 6}, 2 });
    for ( auto point : pointInRange ){
        std::cout << point  << std::endl;
    }





}